package net.wanji.opt.service.induce.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import lombok.extern.slf4j.Slf4j;
import net.wanji.common.utils.tool.StringUtils;
import net.wanji.opt.dao.mapper.induce.InduceFontHistMapper;
import net.wanji.opt.entity.InduceFontHist;
import net.wanji.opt.service.induce.InduceFontHistService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Objects;

/**
 * @author duanruiming
 * @date 2025/01/21 14:39
 */
@Service
@Slf4j
public class InduceFontHistServiceImpl implements InduceFontHistService {

    @Resource
    private InduceFontHistMapper induceFontHistMapper;

    @Override
    public List<InduceFontHist> getAll(String equipCode) {
        LambdaQueryWrapper<InduceFontHist> queryWrapper = new LambdaQueryWrapper<>();
        if (StringUtils.isNotBlank(equipCode)) {
            queryWrapper.eq(InduceFontHist::getEquipCode, equipCode);
            queryWrapper.orderByDesc(InduceFontHist::getGmtModified);
        }
        List<InduceFontHist> induceFontHists = induceFontHistMapper.selectList(queryWrapper);
        return induceFontHists;
    }

    @Override
    public void editor(InduceFontHist induceFontHist) {
        if (Objects.nonNull(induceFontHist)) {
            Long id = induceFontHist.getId();
            if (Objects.isNull(id)) {
                induceFontHistMapper.insert(induceFontHist);
            } else {
                induceFontHist.setGmtModified(new Date());
                induceFontHistMapper.updateById(induceFontHist);
            }
        }
    }

    @Override
    public InduceFontHist getLastOne(String equipCode) {
        if (StringUtils.isNotBlank(equipCode)) {
            LambdaQueryWrapper<InduceFontHist> queryWrapper = new LambdaQueryWrapper<>();
            queryWrapper.eq(InduceFontHist::getEquipCode, equipCode);
            queryWrapper.orderByDesc(InduceFontHist::getGmtModified);
            queryWrapper.last("limit 1");
            InduceFontHist induceFontHist = induceFontHistMapper.selectOne(queryWrapper);
            return induceFontHist;
        }
        return null;
    }
}
